【LeetCode】1024. 视频拼接(Java)

你将会获得一系列视频片段,这些片段来自于一项持续时长为 T 秒的体育赛事。这些片段可能有所重叠,也可能长度不一。

视频片段 clips[i] 都用区间进行表示:开始于 clips[i][0] 并于 clips[i][1] 结束。我们甚至可以对这些片段自由地再剪辑,例如片段 [0, 7] 可以剪切成 [0, 1] + [1, 3] + [3, 7] 三部分。

我们需要将这些片段进行再剪辑,并将剪辑后的内容拼接成覆盖整个运动过程的片段([0, T])。返回所需片段的最小数目,如果无法完成该任务,则返回 -1 。

提示:

    1 <= clips.length <= 100 0 <= clips[i][0] <= clips[i][1] <= 100 0 <= T <= 100

解法一

动态规划

class Solution {
          
   
    public int videoStitching(int[][] clips, int T) {
          
   
        // 动态规划
        // 用于存放满足持续时长的片段数(每个下标对应持续时长,内容为这个时长的最少片段)
        int[] dp = new int[T + 1];
        // dp数组里的所有元素替换成Integer.MAX_VALUE - 1
        Arrays.fill(dp, Integer.MAX_VALUE - 1);
        // 0代表持续时长为0的情况
        dp[0] = 0;
        // 假设持续时长为i,遍历clips数组,找出最少片段数
        for (int i = 1; i <= T; i++) {
          
   
            for (int[] clip : clips) {
          
   
                // 如果当前片段的起始点小于i(当前持续片段长),并且结束点大于等于i
                if (clip[0] < i && clip[1] >= i) {
          
   
                    // 比较 i(当前持续时长)在dp的片段数 和 以当前片段的起始点在dp数组下标的片段数+1(就是从0到当前片段的起始点的持续时长需要的片段数加1(加1为加上当前的片段))
                    // 哪个小,哪个就保存到dp的当前位置(因为可能不止一个片段满足条件)
                    dp[i] = Math.min(dp[i], dp[clip[0]] + 1);
                }
            }
        }
        // 如果dp数组的最后位置还是初始值(),说明不能组成持续时长T,返回-1,否则返回持续时长T的最小片段
        return dp[T] == Integer.MAX_VALUE - 1 ? -1 : dp[T];
    }
}

如果注释没看懂的话,应该是我写得不太好,可以去看官方的题解思路,这道题贪心是最优解。

解法二

贪心

class Solution {
          
   
    public int videoStitching(int[][] clips, int T) {
          
   
        // 贪心
        // maxs数组下标代表起始点,内容代表结束点(因为可能有重复的起始点,所以只保保存最长的)
        int[] maxs = new int[T];
        // 遍历每个片段,保存到maxs数组中的对应位置
        for (int[] clip : clips) {
          
   
            // 保证起始点小于T,防止越界
            if (clip[0] < T) {
          
   
                maxs[clip[0]] = Math.max(maxs[clip[0]], clip[1]);
            }
        }

        int count = 0;  // 片段数
        int pre = 0;    // 前个片段的结束点
        int last = 0;   // 当前片段的结束点
        for (int i = 0; i < T; i++) {
          
   
            // 比较当前片段结束点 和 数组中这个位置的结束点 哪个长,保存哪个
            last = Math.max(last, maxs[i]);
            // 如果当前片段的结束点等于i,说明下一个点已经包含在持续时长里了
            // 如果第一个点不存在,那么last和maxs[0]都会是0,此时i也是0,所以会直接返回-1
            // 如果是中间某个点不存在,那么last也刚好等于i
            // 如果T最后的点不存在,循环只到T-1,i = T-1,说明T的最后的点不存在
            if (last == i) {
          
   
                return -1;
            }
            // pre总是会大于i的,如果相等,pre再次移动,并且片段数加1
            if (pre == i) {
          
   
                pre = last;
                count++;
            }
        }
        return count;
    }
}

祝各位同行们节日快乐~

(最后,留个彩蛋:2020 - 1024 = ? (手动狗头))

经验分享 程序员 微信小程序 职场和发展